﻿namespace ConsoleApp.Models;

public class Service
{
    public int Id { get; private set; }
    public int Capacity { get; private set; }
    public bool IsActive { get; private set; } = true;

    public Service(int id, int capacity)
    {
        Id = id;
        Capacity = capacity;
    }
     
    public bool HasCapacity()
    {
        return Capacity > 0;
    }

    public void DecrementCapacity()
    {
        if (HasCapacity())
        {
            Capacity--;
            IsActive = true;
        }
        else
        {
            IsActive = false;
        }
    }

    public void IncrementCapacity()
    {
        Capacity++;
    }

    public bool ToExecute(Func<bool> functionToExecute)
    {
     throw new NotImplementedException();
    }
}
